VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ITimerEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_sngInterval As Single
Private m_bEnabled    As Boolean

Private WithEvents Timer As ITimer
Attribute Timer.VB_VarHelpID = -1
Public Event Timer()

Private Const MAX_INTERVAL = 86400000 '24 hrs
Public Property Get Interval() As Single
    Interval = m_sngInterval
End Property

Public Property Let Interval(ByVal sngNewValue As Single)
      
    Dim sngTmpValue As Single
    
    sngTmpValue = sngNewValue
    If sngTmpValue <= 0 Then
        sngTmpValue = 0
    End If
        
    If sngTmpValue > MAX_INTERVAL Then
        sngTmpValue = MAX_INTERVAL
    End If

    If sngTmpValue <> m_sngInterval Then
        If sngTmpValue = 0 And Enabled Then
            m_sngInterval = 0
            StopTimer
        ElseIf sngTmpValue And Enabled Then
            m_sngInterval = sngTmpValue
            StopTimer
            StartTimer (m_sngInterval)
        Else
            m_sngInterval = sngTmpValue
        End If
    End If
        

End Property

Public Property Get Enabled() As Boolean
     Enabled = m_bEnabled
End Property

Public Property Let Enabled(ByVal bNewValue As Boolean)
    
    m_bEnabled = bNewValue
    
    If m_bEnabled Then
        If m_sngInterval Then
            StartTimer m_sngInterval
        End If
    Else
        StopTimer
    End If
    
End Property


Private Sub Class_Initialize()
    Set Timer = m_objEventSource
End Sub

Private Sub Class_Terminate()
     StopTimer
     Set Timer = Nothing
End Sub


Private Sub Timer_TimerEventSource()
    RaiseEvent Timer
End Sub


